// Ensure that the build script itself is not opted in to null safety,
// instead of taking the language version from the current package.
//
// @dart=2.9
//
// ignore_for_file: directives_ordering

import 'package:build_runner_core/build_runner_core.dart' as _i1;
import 'package:source_gen/builder.dart' as _i2;
import 'package:xanno/src/anno/project/generator.dart' as _i3;
import 'package:xanno/src/anno/api/generator.dart' as _i4;
import 'package:xanno/src/anno/assets/generator.dart' as _i5;
import 'package:xanno/src/anno/iconfont/generator.dart' as _i6;
import 'package:xanno/src/anno/route/generator.dart' as _i7;
import 'package:xanno/src/anno/entity/generator.dart' as _i8;
import 'package:xanno/src/anno/http/generator.dart' as _i9;
import 'package:xanno/src/anno/formatter/generator.dart' as _i10;
import 'package:xanno/src/anno/color/generator.dart' as _i11;
import 'package:xanno/src/anno/size/generator.dart' as _i12;
import 'package:xanno/src/anno/localizations/generator.dart' as _i13;
import 'package:xanno/src/anno/doc/generator.dart' as _i14;
import 'package:build_config/build_config.dart' as _i15;
import 'dart:isolate' as _i16;
import 'package:build_runner/build_runner.dart' as _i17;
import 'dart:io' as _i18;

final _builders = <_i1.BuilderApplication>[
  _i1.apply('source_gen:combining_builder', [_i2.combiningBuilder],
      _i1.toNoneByDefault(),
      hideOutput: false, appliesBuilders: ['source_gen:part_cleanup']),
//  _i1.apply('xanno:projectBuilder', [_i3.projectBuilder], _i1.toAllPackages(),
//      hideOutput: false, appliesBuilders: ['xanno:apiBuilder']),
//  _i1.apply('xanno:apiBuilder', [_i4.apiBuilder], _i1.toAllPackages(),
//      hideOutput: false, appliesBuilders: ['xanno:assetsBuilder']),
//  _i1.apply('xanno:assetsBuilder', [_i5.assetsBuilder], _i1.toAllPackages(),
//      hideOutput: false, appliesBuilders: ['xanno:iconfontBuilder']),
//  _i1.apply('xanno:iconfontBuilder', [_i6.iconfontBuilder], _i1.toAllPackages(),
//      hideOutput: false, appliesBuilders: ['xanno:routeBuilder']),
//  _i1.apply('xanno:routeBuilder', [_i7.routeBuilder], _i1.toAllPackages(),
//      hideOutput: false, appliesBuilders: ['xanno:entityBuilder']),
//  _i1.apply('xanno:entityBuilder', [_i8.entityBuilder], _i1.toAllPackages(),
//      hideOutput: false, appliesBuilders: ['xanno:httpInterfaceBuilder']),
//  _i1.apply('xanno:httpInterfaceBuilder', [_i9.httpInterfaceBuilder],
//      _i1.toAllPackages(),
//      hideOutput: false, appliesBuilders: ['xanno:formatterBuilder']),
//  _i1.apply(
//      'xanno:formatterBuilder', [_i10.formatterBuilder], _i1.toAllPackages(),
//      hideOutput: false, appliesBuilders: ['xanno:colorBuilder']),
//  _i1.apply('xanno:colorBuilder', [_i11.colorBuilder], _i1.toAllPackages(),
//      hideOutput: false, appliesBuilders: ['xanno:sizeBuilder']),
//  _i1.apply('xanno:sizeBuilder', [_i12.sizeBuilder], _i1.toAllPackages(),
//      hideOutput: false, appliesBuilders: ['xanno:localeBuilder']),
//  _i1.apply('xanno:localeBuilder', [_i13.localeBuilder], _i1.toAllPackages(),
//      hideOutput: false, appliesBuilders: ['xanno:docBuilder']),
//  _i1.apply('xanno:docBuilder', [_i14.docBuilder], _i1.toAllPackages(),
//      hideOutput: false),

  _i1.apply('xanno:httpInterfaceBuilder', [_i9.httpInterfaceBuilder],
      _i1.toAllPackages(),
      hideOutput: false),

  _i1.applyPostProcess('source_gen:part_cleanup', _i2.partCleanup,
      defaultGenerateFor: const _i15.InputSet())
];

void main(List<String> args, [_i16.SendPort sendPort]) async {
  var result = await _i17.run(args, _builders);
  sendPort?.send(result);
  _i18.exitCode = result;
}
