// ignore: implementation_imports
import 'package:build/src/builder/build_step.dart';
import 'package:analyzer/dart/element/element.dart' as ele;
import 'dart:async';
import 'package:source_gen/source_gen.dart';
import 'package:build/build.dart';
import 'package:xanno/xanno.dart';

class DocGenerator extends Generator {
  const DocGenerator();

  TypeChecker get typeChecker => TypeChecker.fromRuntime(GRoute);

  @override
  FutureOr<String> generate(LibraryReader library, BuildStep buildStep) async {
    final values = <String>{};

//    for (var annotatedElement in library.annotatedWith(typeChecker)) {
//      final generatedValue = generateForAnnotatedElement(
//          annotatedElement.element, annotatedElement.annotation, buildStep);
//      await for (var value in normalizeGeneratorOutput(generatedValue)) {
//        assert(value == null || (value.length == value.trim().length));
//        values.add(value);
//      }
//    }

    for (var annotatedElement in library.annotatedWith(typeChecker)) {
      generateForAnnotatedElement(
          annotatedElement.element, annotatedElement.annotation, buildStep);
    }

//    for (ele.ClassElement v in library.classes) {
//      print('DocGenerator classes $v');
//    }
//
//    for (var v in library.enums) {
//      print('DocGenerator enums $v');
//    }
//
//    for (var v in library.allElements) {
//      print('DocGenerator allElements $v');
//    }

    return values.join('\n\n');
  }

  generateForAnnotatedElement(
      ele.Element element, ConstantReader annotation, BuildStep buildStep) {
    if (element.kind == ele.ElementKind.CLASS) {
//      for (var e in ((element as ele.ClassElement).methods)) {
//        print(e.toString());
//        e.metadata.forEach((v) {
//          print(e.metadata.first.toSource());
//        });
//      }
//      0.0.1 master
    }
    return null;
  }
}

Builder docBuilder(BuilderOptions options) =>
    LibraryBuilder(DocGenerator(), generatedExtension: ".doc.dart");
