///使用示例
///   import 'package:hw_checker/annotation/entity/entity.dart';
///
///   @GEntity(json: '''
///   {
///       "name": "爸爸",
///       "age": 30,
///       "wife": {
///           "name": "妈妈",
///           "age": 28,
///           "beautiful": true
///       },
///       "childList": [
///           {
///               "name": "孩子1",
///               "age": 1,
///               "sex": "男"
///           },
///           {
///               "name": "孩子2",
///               "age": 2,
///               "sex": "女"
///           }
///       ]
///   }
///   ''', auto: true)
///   class JsonEntity {}

class GEntity {
  ///json string
  final String json;

  ///是否自动生成, 默认会第一次生成之后自动关闭，提高效率
  final bool auto;

  final bool enable;

  const GEntity({this.json, this.auto, this.enable = true});
}
