import 'tpl_build_sh.dart' as build_sh;
import 'tpl_main.dart' as main;
import 'tpl_app.dart' as app;
import 'tpl_store_main.dart' as store_main;
import 'tpl_store_reducers.dart' as store_reducers;
import 'tpl_store_redux_middleware.dart' as store_redux_middleware;
import 'tpl_widget_base_store_container.dart' as widget_base_store_container;
import 'tpl_common_localization_constant.dart' as common_localization_constant;
import 'tpl_debug_app_debug_model.dart' as debug_app_debug_model;
import 'tpl_route_main.dart' as route_main;
import 'tpl_utils_print_util.dart' as utils_print_util;
import 'tpl_utils_screen_util.dart' as utils_screen_util;
import 'tpl_pages_main_main_page.dart' as pages_main_main_page;
import 'tpl_debug_main.dart' as debug_main;
import 'tpl_debug_app_debug.dart' as debug_app_debug;
import 'tpl_debug_app_error_content_log.dart' as debug_app_error_content_log;
import 'tpl_debug_app_error_log.dart' as debug_app_error_log;
import 'tpl_store_user_main.dart' as store_user_main;
import 'tpl_pages_main_store_actions.dart' as pages_main_store_actions;
import 'tpl_api_interceptors_log_interceptors.dart' as api_interceptors_log_interceptors;
import 'tpl_api_entity_base_entity.dart' as api_entity_base_entity;
import 'tpl_api_entity_entity_factory.dart' as api_entity_entity_factory;
import 'tpl_api_interceptors_request_interceptors.dart' as api_interceptors_request_interceptors;
import 'tpl_api_interceptors_response_interceptors.dart' as api_interceptors_response_interceptors;
import 'tpl_api_manager_http_manager.dart' as api_manager_http_manager;
import 'tpl_api_transformer_transformer.dart' as api_transformer_transformer;
import 'tpl_api_api_factory.dart' as api_api_factory;
import 'tpl_api_api_interface.dart' as api_api_interface;
import 'tpl_pages_main_store_reducers.dart' as pages_main_store_reducers;
import 'tpl_pages_main_store_constant.dart' as pages_main_store_constant;
import 'tpl_utils_toast_util.dart' as utils_toast_util;
import 'tpl_store_base_action.dart' as store_base_action;

class FileInfo {
  final String filePath;
  final String Function({dynamic package}) codeBuild;

  const FileInfo({this.filePath, this.codeBuild});
}

class Tpl {

  static dynamic get buildSh => build_sh.clazzTpl;

  static List<FileInfo> get buildCode => [
        FileInfo(filePath: 'main.dart', codeBuild: main.clazzTpl),
        FileInfo(filePath: 'app.dart', codeBuild: app.clazzTpl),

        FileInfo(filePath: 'store/main.dart', codeBuild: store_main.clazzTpl),
        FileInfo(filePath: 'store/reducers.dart', codeBuild: store_reducers.clazzTpl),
        FileInfo(filePath: 'store/redux_middleware.dart', codeBuild: store_redux_middleware.clazzTpl),
        FileInfo(filePath: 'store/user/main.dart', codeBuild: store_user_main.clazzTpl),
        FileInfo(filePath: 'store/base_action.dart', codeBuild: store_base_action.clazzTpl),

        FileInfo(filePath: 'widget/base_store_container.dart', codeBuild: widget_base_store_container.clazzTpl),
        FileInfo(filePath: 'common/localization_constant.local.dart', codeBuild: common_localization_constant.clazzTpl),

        FileInfo(filePath: 'route/main.route.dart', codeBuild: route_main.clazzTpl),

        FileInfo(filePath: 'api/entity/base_entity.api.dart', codeBuild: api_entity_base_entity.clazzTpl),
        FileInfo(filePath: 'api/entity/entity_factory.entity.dart', codeBuild: api_entity_entity_factory.clazzTpl),
        FileInfo(filePath: 'api/interceptors/log_interceptors.api.dart', codeBuild: api_interceptors_log_interceptors.clazzTpl),
        FileInfo(filePath: 'api/interceptors/request_interceptors.api.dart', codeBuild: api_interceptors_request_interceptors.clazzTpl),
        FileInfo(filePath: 'api/interceptors/response_interceptors.api.dart', codeBuild: api_interceptors_response_interceptors.clazzTpl),
        FileInfo(filePath: 'api/manager/http_manager.api.dart', codeBuild: api_manager_http_manager.clazzTpl),
        FileInfo(filePath: 'api/transformer/transformer.dart', codeBuild: api_transformer_transformer.clazzTpl),
        FileInfo(filePath: 'api/api_factory.interface.dart', codeBuild: api_api_factory.clazzTpl),
        FileInfo(filePath: 'api/api_interface.api.dart', codeBuild: api_api_interface.clazzTpl),

        FileInfo(filePath: 'utils/print_util.dart', codeBuild: utils_print_util.clazzTpl),
        FileInfo(filePath: 'utils/screen_util.dart', codeBuild: utils_screen_util.clazzTpl),
        FileInfo(filePath: 'utils/toast_util.dart', codeBuild: utils_toast_util.clazzTpl),

        FileInfo(filePath: 'pages/main/main_page.dart', codeBuild: pages_main_main_page.clazzTpl),
        FileInfo(filePath: 'pages/main/store/actions.dart', codeBuild: pages_main_store_actions.clazzTpl),
        FileInfo(filePath: 'pages/main/store/constant.dart', codeBuild: pages_main_store_constant.clazzTpl),
        FileInfo(filePath: 'pages/main/store/reducers.dart', codeBuild: pages_main_store_reducers.clazzTpl),

        FileInfo(filePath: 'debug/app_debug_model.dart', codeBuild: debug_app_debug_model.clazzTpl),
        FileInfo(filePath: 'debug/main.dart', codeBuild: debug_main.clazzTpl),
        FileInfo(filePath: 'debug/app_debug.dart', codeBuild: debug_app_debug.clazzTpl),
        FileInfo(filePath: 'debug/app_error_content_log.dart', codeBuild: debug_app_error_content_log.clazzTpl),
        FileInfo(filePath: 'debug/app_error_log.dart', codeBuild: debug_app_error_log.clazzTpl),
      ];
}
