String clazzTpl({package}) => """
import 'dart:io';
import 'dart:convert';
import 'package:dio/dio.dart';
import 'api_interface.api.dart';
import 'package:xanno/xanno.dart';
import 'entity/base_entity.api.dart';
import 'manager/http_manager.api.dart';
import 'package:http_parser/http_parser.dart' show MediaType;

class ApiFactory extends ApiInterface {
  ApiFactory({this.host}) {
    host ??= 'https://api.muxiaoguo.cn/api/';
  }

  String host;

  @override
  Future<List<dynamic>> getTags(cancelReq) async {
    const extra = <String, dynamic>{'extraKey': 1, 'extraKey2': '2'};
    final queryParameters = <String, dynamic>{};
    final data = <String, dynamic>{};
    final resp = await HttpManager(host: host).request<dynamic>('/tags',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data,
        cancelToken: cancelReq);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Stream<List<String>> getTagsAsStream() async* {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = <String, dynamic>{};
    final resp = await HttpManager(host: host).request<String>('/tags',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      yield resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        yield resp.data;
      }
    }
  }

  @override
  Future<List<dynamic>> getTasks() async {
    const extra = <String, dynamic>{'isLoading': true};
    final queryParameters = <String, dynamic>{};
    final data = <String, dynamic>{};
    final resp = await HttpManager(host: host).request<dynamic>('/tasks',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<dynamic> getTask(id) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = <String, dynamic>{};
    final resp = await HttpManager(host: host).request<dynamic>('/tasks/\$id',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<dynamic> updateTaskPart(id, map) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = <String, dynamic>{};
    data.addAll(map ?? <String, dynamic>{});
    data.removeWhere((k, v) => v == null);
    final resp = await HttpManager(host: host).request<dynamic>('/tasks/\$id',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'PATCH',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<dynamic> updateTask(id, task) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = task;
    final resp = await HttpManager(host: host).request<dynamic>('/tasks/\$id',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'PUT',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<void> deleteTask(id) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = <String, dynamic>{};
    await HttpManager(host: host).request<void>('/tasks/\$id',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'DELETE',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    return null;
  }

  @override
  Future<dynamic> createTask(task) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = task;
    final resp = await HttpManager(host: host).request<dynamic>('/tasks',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'POST',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<List<dynamic>> createTasks(tasks) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = tasks.map((e) => e.toJson()).toList();
    final resp = await HttpManager(host: host).request<dynamic>('/tasks',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'POST',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<List<String>> createTaskNames(tasks) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = tasks.map((e) => e).toList();
    final resp = await HttpManager(host: host).request<String>('/tasks',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'POST',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<void> createNewTaskFromFile(file) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = FormData();
    data.files.add(MapEntry(
        'file',
        MultipartFile.fromFileSync(file.path,
            filename: file.path.split(Platform.pathSeparator).last)));
    await HttpManager(host: host).request<void>('',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'POST',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    return null;
  }

  @override
  Future<List<int>> getFile() async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = <String, dynamic>{};
    final resp = await HttpManager(host: host).request<int>('',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{r'accept': 'image/jpeg'},
            extra: extra,
            baseUrl: host,
            responseType: ResponseType.bytes),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<String> postUrlEncodedFormData(hello, {gg}) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    queryParameters.removeWhere((k, v) => v == null);
    final data = {'hello': hello, 'gg': gg};
    data.removeWhere((k, v) => v == null);
    final resp = await HttpManager(host: host).request<String>('',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'POST',
            headers: <String, dynamic>{},
            extra: extra,
            contentType: 'application/x-www-form-urlencoded',
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<String> headRequest() async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = <String, dynamic>{};
    final resp = await HttpManager(host: host).request<String>('/',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'HEAD',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<dynamic> headRquest2() async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = <String, dynamic>{};
    final resp = await HttpManager(host: host).request<dynamic>('/',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'HEAD',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<HttpResponse<dynamic>> headRquest3() async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = <String, dynamic>{};
    final resp = await HttpManager(host: host).request<dynamic>('/',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'HEAD',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    final httpResponse = HttpResponse(resp.data, resp);
    return httpResponse;
  }

  @override
  Future<List<dynamic>> grouppedTaskByDate() async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = <String, dynamic>{};
    final resp = await HttpManager(host: host).request<dynamic>('/task/group',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<HttpResponse<List<dynamic>>> getTasksWithReponse() async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = <String, dynamic>{};
    final resp = await HttpManager(host: host).request<dynamic>('/task',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    final httpResponse = HttpResponse(resp.data, resp);
    return httpResponse;
  }

  @override
  Future<HttpResponse<void>> deleteTaskWithResponse(id) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = <String, dynamic>{};
    final resp = await HttpManager(host: host).request<void>('/tasks/\$id',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'DELETE',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    final httpResponse = HttpResponse(resp.data, resp);
    return httpResponse;
  }

  @override
  Future<String> postFormData(task, {file}) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    queryParameters.removeWhere((k, v) => v == null);
    final data = FormData();
    data.fields.add(MapEntry('task', task));
    if (file != null) {
      data.files.add(MapEntry(
          'file',
          MultipartFile.fromFileSync(file.path,
              filename: file.path.split(Platform.pathSeparator).last)));
    }
    final resp = await HttpManager(host: host).request<String>('/post',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'POST',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<String> postFormData2(task, tags, file) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = FormData();
    task?.forEach((i) {
      data.fields.add(MapEntry('task', jsonEncode(i)));
    });
    tags?.forEach((i) {
      data.fields.add(MapEntry('tags', jsonEncode(i)));
    });
    data.files.add(MapEntry(
        'file',
        MultipartFile.fromFileSync(file.path,
            filename: file.path.split(Platform.pathSeparator).last,
            contentType: MediaType.parse('application/json'))));
    final resp = await HttpManager(host: host).request<String>('/post',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'POST',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<String> postFormData3({files, file}) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    queryParameters.removeWhere((k, v) => v == null);
    final data = FormData();
    data.files.addAll(files?.map((i) => MapEntry(
        'customfiles',
        MultipartFile.fromFileSync(
          i.path,
          filename: i.path.split(Platform.pathSeparator).last,
          contentType: MediaType.parse('application/json'),
        ))));
    if (file != null) {
      data.files.add(MapEntry(
          'file',
          MultipartFile.fromFileSync(file.path,
              filename: file.path.split(Platform.pathSeparator).last)));
    }
    final resp = await HttpManager(host: host).request<String>('/post',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'POST',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<String> postFormData6({files, file}) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    queryParameters.removeWhere((k, v) => v == null);
    final data = FormData();
    data.files.addAll(files?.map((i) => MapEntry(
        'customfiles',
        MultipartFile.fromBytes(
          i,
        ))));
    data.files.add(MapEntry(
        'file',
        MultipartFile.fromBytes(
          file,
          filename: null,
        )));
    final resp = await HttpManager(host: host).request<String>('/post',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'POST',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<String> postFormData4(tasks, file) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = FormData();
    data.files.add(MapEntry(
        'file',
        MultipartFile.fromFileSync(file.path,
            filename: file.path.split(Platform.pathSeparator).last)));
    final resp = await HttpManager(host: host).request<String>('/post',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'POST',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<String> postFormData5(tasks, map, a, {b, c, d}) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    queryParameters.removeWhere((k, v) => v == null);
    final data = FormData();
    data.fields.add(MapEntry('map', jsonEncode(map)));
    if (a != null) {
      data.fields.add(MapEntry('a', a.toString()));
    }
    if (b != null) {
      data.fields.add(MapEntry('b', b.toString()));
    }
    if (c != null) {
      data.fields.add(MapEntry('c', c.toString()));
    }
    if (d != null) {
      data.fields.add(MapEntry('d', d));
    }
    final resp = await HttpManager(host: host).request<String>('/post',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'POST',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<String> queries(queries) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    queryParameters.addAll(queries ?? <String, dynamic>{});
    final data = <String, dynamic>{};
    final resp = await HttpManager(host: host).request<String>('/demo',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<String> queryByEnum(query) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{r'tasks': null};
    final data = <String, dynamic>{};
    final resp = await HttpManager(host: host).request<String>('/enums',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<String> namedExample(apiKey, scope, type, {from}) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{
      r'apikey': apiKey,
      r'scope': scope,
      r'type': type,
      r'from': from
    };
    queryParameters.removeWhere((k, v) => v == null);
    final data = <String, dynamic>{};
    final resp = await HttpManager(host: host).request<String>('/get',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'GET',
            headers: <String, dynamic>{},
            extra: extra,
            baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<String> postFile({file, sendProgress, receiveProgress}) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    queryParameters.removeWhere((k, v) => v == null);
    final data = Stream.fromIterable(file.readAsBytesSync().map((i) => [i]));
    final resp = await HttpManager(host: host).request<String>('/postfile',
        queryParameters: queryParameters,
        options: RequestOptions(
            method: 'POST',
            headers: <String, dynamic>{
              r'Content-Type': 'application/octet-stream',
              r'Ocp-Apim-Subscription-Key': 'abc'
            },
            extra: extra,
            contentType: 'application/octet-stream',
            baseUrl: host),
        data: data,
        onSendProgress: sendProgress,
        onReceiveProgress: receiveProgress);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  @override
  Future<String> testCustomOptions(options) async {
    const extra = <String, dynamic>{};
    final queryParameters = <String, dynamic>{};
    final data = <String, dynamic>{};
    final newOptions = newRequestOptions(options);
    newOptions.extra.addAll(extra);
    newOptions.headers.addAll(<String, dynamic>{});
    final resp = await HttpManager(host: host).request<String>('',
        queryParameters: queryParameters,
        options: newOptions.merge(method: 'GET', baseUrl: host),
        data: data);
    if (resp.data is BaseEntity) {
      return resp.data.data;
    } else {
      if (resp.data is DioError) {
        throw resp.data;
      } else {
        return resp.data;
      }
    }
  }

  RequestOptions newRequestOptions(Options options) {
    if (options is RequestOptions) {
      return options;
    }
    if (options == null) {
      return RequestOptions();
    }
    return RequestOptions(
      method: options.method,
      sendTimeout: options.sendTimeout,
      receiveTimeout: options.receiveTimeout,
      extra: options.extra,
      headers: options.headers,
      responseType: options.responseType,
      contentType: options.contentType.toString(),
      validateStatus: options.validateStatus,
      receiveDataWhenStatusError: options.receiveDataWhenStatusError,
      followRedirects: options.followRedirects,
      maxRedirects: options.maxRedirects,
      requestEncoder: options.requestEncoder,
      responseDecoder: options.responseDecoder,
    );
  }
}
""";
