String clazzTpl({package}) => """
import 'dart:convert';
import 'entity_factory.entity.dart';

/// 请叫我code哥
/// Generates Dart code
///支持的key
const codeKeyList = ['code'];
const msgKeyList = ['msg', 'message'];
const dataKeyList = ['', 'data', 'result', 'deviceinfo'];

class BaseEntity<T> {
  dynamic code;
  String message;
  dynamic data;

  BaseEntity({this.code, this.message, this.data});

  static String _findCodeKey(json) {
    try {
      return codeKeyList.firstWhere((element) => json.containsKey(element));
    } catch (e) {
      return null;
    }
  }

  static String _findMsgKey(json) {
    try {
      return msgKeyList.firstWhere((element) => json.containsKey(element));
    } catch (e) {
      return null;
    }
  }

  static String _findDataKey(json) {
    if (json is Map) {
      try {
        return dataKeyList.firstWhere((element) => json.containsKey(element));
      } catch (e) {
        return null;
      }
    } else {
      //没有key，直接返回数组
      return '__Array__';
    }
  }

  BaseEntity.init(
      {dynamic jsonData, List<T> mListData, bool isRespList, bool isDataList}) {
    if (isRespList) {
      this.data = mListData;
    } else {
      var code = jsonData[_findCodeKey(jsonData) ?? ''];
      var message = jsonData[_findMsgKey(jsonData) ?? ''];
      if (code != null) this.code = code;
      if (message != null) this.message = message;
      if (isDataList) {
        this.data = mListData;
      } else {
        if (mListData != null && mListData.isNotEmpty)
          this.data = mListData.first;
      }
    }
  }

  factory BaseEntity.fromJson(dynamic resp) {
    var jsonData;
    bool isRespList = false, isDataList = false;
    if (resp is String) {
      try {
        jsonData = jsonDecode(resp);
      } catch (e) {
        return BaseEntity(data: resp);
      }
    } else if (resp is Map) {
      jsonData = resp;
    }
    List<T> mListData = [];
    var dataKey = _findDataKey(jsonData);
    if (jsonData is Map && jsonData[dataKey] != null) {
      isRespList = false;
      if (jsonData[dataKey] is List) {
        isDataList = true;
        mListData = (jsonData[dataKey] as List).map<T>((v) {
          return EntityFactory.generateOBJ<T>(v);
        }).toList();
      } else {
        isDataList = false;
        mListData.add(EntityFactory.generateOBJ<T>(jsonData[dataKey]));
      }
    } else {
      //没有key，直接返回数组
      if (dataKey == '__Array__') {
        isRespList = true;
        if (jsonData is List) {
          mListData = jsonData.map<T>((v) {
            return EntityFactory.generateOBJ<T>(v);
          }).toList();
        }
      }
    }
    return BaseEntity.init(
        jsonData: jsonData,
        mListData: mListData,
        isRespList: isRespList,
        isDataList: isDataList);
  }
}
""";
