String clazzTpl({package, n = r"\n", t = r"\t", r = r"\r"}) => """
import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:$package/route/main.route.dart';

/// 请叫我code哥
/// Generates Dart code
class CustomLocale {
  static Locale en = const Locale('en', 'US');
  static Locale zh = const Locale('zh', 'CN');
}

/// 自动生成
class CustomLocalizationDelegate
    extends LocalizationsDelegate<CustomLocalizations> {
  @override
  bool isSupported(Locale locale) {
    return ['en', 'zh'].contains(locale.languageCode);
  }

  @override
  Future<CustomLocalizations> load(Locale locale) {
    return SynchronousFuture(CustomLocalizations(locale));
  }

  @override
  bool shouldReload(LocalizationsDelegate<CustomLocalizations> old) => false;
}

/// 自动生成
class CustomLocalizations {
  CustomLocalizations(this._locale);

  final Locale _locale;

  static CustomLocalizations of(BuildContext context) {
    if (context == null) {
      return Localizations.of(
          globalNavigatorKey.currentContext, CustomLocalizations);
    }
    try {
      return Localizations.of(context, CustomLocalizations);
    } catch (e) {
      return Localizations.of(
          globalNavigatorKey.currentContext, CustomLocalizations);
    }
  }

  String _local(Map<String, Map<String, String>> map) {
    map.forEach((key, value) {
      map[key] = value.map((key, value) {
        value = value.replaceAll('\\$n', '$n');
        value = value.replaceAll('\\$t', '$t');
        value = value.replaceAll('\\$r', '$t');
        return MapEntry(key, value);
      });
    });

    _LOCALIZATION_MAP.addAll(map);
    return _localeValue(key: map.keys.first);
  }

  String _localeValue({@required String key}) {
    var value = _LOCALIZATION_MAP[key][_locale.languageCode];
    value = value.replaceAll('\\$n', '$n');
    value = value.replaceAll('\\$t', '$t');
    value = value.replaceAll('\\$r', '$t');

    return value;
  }
}

/// 自动生成
class I18N {
  static String local(String key, {@required String en, @required String zh}) {
    return CustomLocalizations.of(null)._local({
      key: {'en': en, 'zh': zh}
    });
  }
}

/// 自动生成
// ignore: non_constant_identifier_names
Map<String, Map<String, String>> _LOCALIZATION_MAP = {

};
""";
