String clazzTpl({package}) => """
import 'package:$package/pages/main/store/actions.dart';
import 'package:$package/route/main.route.dart';
import 'package:$package/widget/base_store_container.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:xanno/xanno.dart';
import 'app_debug_model.dart';

@GRoute(url: '/appDebug', title: 'AppDebug')
class AppDebugPage extends StatelessWidget {
  final String title;

  const AppDebugPage({Key key, this.title}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return BaseStoreContainer(
      builder: (context, store) {
        List<AppDebugModel> newData = store.state.userState.appDebug;
        return Scaffold(
          appBar: AppBar(
            title: Text(title),
          ),
          body: ListView.separated(
            itemCount: newData.length,
            separatorBuilder: (BuildContext context, int index) {
              return Divider(
                color: Colors.white,
                height: 1,
              );
            },
            itemBuilder: (BuildContext context, int index) {
              AppDebugModel item = newData[index];
              return GestureDetector(
                onTap: () {
                  if (item.key == AppDebugKey.errorLog) {
                    Navigator.pushNamed(context, RouteConstant.AppErrorLogPage);
                  }
                },
                child: ListTile(
                  title: Text(item.title),
                  subtitle: Text('\${item.on ? '开启' : '关闭'}功能'),
                  tileColor: Colors.grey[300],
                  trailing: [AppDebugKey.errorLog]
                          .contains(item.key)
                      ? Icon(Icons.keyboard_arrow_right, size: 30)
                      : CupertinoSwitch(
                          value: item.on,
                          onChanged: (bool value) {
                            item.on = !item.on;
                            store.dispatch(updateAppDebug(newData));
                          },
                        ),
                ),
              );
            },
          ),
        );
      },
    );
  }
}
""";
