String clazzTpl({package}) => """
import 'dart:io';
import 'package:$package/api/interceptors/log_interceptors.api.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:xanno/xanno.dart';
import 'package:path_provider/path_provider.dart';

@GRoute(url: '/appErrorContentLog', title: 'AppErrorContentLog')
class AppErrorContentLogPage extends StatefulWidget {
  final String title;

  const AppErrorContentLogPage({Key key, this.title}) : super(key: key);

  @override
  _AppErrorContentLogPageState createState() => _AppErrorContentLogPageState();
}

class _AppErrorContentLogPageState extends State<AppErrorContentLogPage> {
  String _content = '';
  bool _isJson = false;

  @override
  void didChangeDependencies() {
    Map map = ModalRoute.of(context).settings.arguments;
    bool boo = map['isError'];
    if (boo) {
      _readErrorFile(map['name']);
    } else {
      
    }
    super.didChangeDependencies();
  }

  void _readErrorFile(String name) async {
    Directory dir = await getApplicationDocumentsDirectory();
    _content =
        await File('\${dir.path}\${Platform.pathSeparator}\$name').readAsString();
    setState(() {});
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(widget.title),
      ),
      body: SingleChildScrollView(
        child: Text(_isJson ? LogInterceptors.formatJson(_content) : _content),
      ),
    );
  }
}
""";
