String clazzTpl({package}) => """
import 'dart:io';
import 'package:$package/route/main.route.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:xanno/xanno.dart';
import 'package:path_provider/path_provider.dart';

@GRoute(url: '/appErrorLog', title: 'AppErrorLog')
class AppErrorLogPage extends StatefulWidget {
  final String title;

  const AppErrorLogPage({Key key, this.title}) : super(key: key);

  @override
  _AppErrorLogPageState createState() => _AppErrorLogPageState();
}

class _AppErrorLogPageState extends State<AppErrorLogPage> {
  List<FileSystemEntity> _files = [];

  @override
  void initState() {
    _readErrorFile();
    super.initState();
  }

  void _readErrorFile() async {
    Directory dir = await getApplicationDocumentsDirectory();
    var files = await dir.list().toList();
    try {
      _files = files.where((element) => element.path.endsWith('.log')).toList();
    } catch (e) {}
    setState(() {});
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(widget.title),
      ),
      body: ListView.separated(
        itemCount: _files.length,
        separatorBuilder: (BuildContext context, int index) {
          return Divider(
            color: Colors.white,
            height: 1,
          );
        },
        itemBuilder: (BuildContext context, int index) {
          FileSystemEntity item = _files[index];
          return GestureDetector(
            onTap: () {
              Navigator.pushNamed(context, RouteConstant.AppErrorContentLogPage,
                  arguments: {
                    'isError': true,
                    'name': item.path.split(Platform.pathSeparator).last
                  });
            },
            child: ListTile(
              title: Text(item.path.split(Platform.pathSeparator).last),
              tileColor: Colors.grey[300],
              trailing: Icon(Icons.keyboard_arrow_right, size: 30),
            ),
          );
        },
      ),
    );
  }
}
""";
