String clazzTpl({package}) => """
import 'package:$package/utils/print_util.dart';
import 'package:redux/redux.dart';
import 'package:logging/logging.dart';
import 'package:redux_thunk/redux_thunk.dart';
import 'package:redux_logging/redux_logging.dart';
import 'main.dart';

final logger = Logger("$package Logger")
  ..onRecord
      .where((record) => record.loggerName == logger.name)
      .listen((loggingMiddlewareRecord) {
    logDebugPrint(loggingMiddlewareRecord?.toString());
  });

final List<Middleware<AppState>> userMiddleware = [
  thunkMiddleware,
  LoggingMiddleware(
      logger: logger,
      level: Level.INFO,
      formatter: LoggingMiddleware.multiLineFormatter),
];
""";
