String clazzTpl({package}) => """
import 'package:flutter/material.dart';
import 'dart:ui';
import 'package:$package/route/main.route.dart';

/// 请叫我code哥
/// Generates Dart code

class ScreenSizeFit {
  static MediaQueryData mediaQueryData;
  static double screenWidth;
  static double screenHeight;
  static double textScaleFactor;
  static double rpx;
  static double px;

  static void init(BuildContext context, {double width = 750}) {
    mediaQueryData =
        MediaQuery.of(context ?? globalNavigatorKey.currentState.context);
    screenWidth = mediaQueryData.size.width;
    screenHeight = mediaQueryData.size.height;
    textScaleFactor = mediaQueryData.textScaleFactor;
    rpx = screenWidth / width;
    px = screenWidth / width * 2;
  }

  /// 按照像素来设置
  static double setPx(double size) => ScreenSizeFit.px * size;

  /// 按照rxp来设置 1rpx=屏幕宽度/750
  static double setRpx(double size) => ScreenSizeFit.rpx * size;
}

///使用方式 SizeConstant.size_px_20 / SizeConstant.size_sp_16
extension ScreenSizeExtension on num {
  ///设置宽高大小
  num get px => ScreenSizeFit.setPx(this.toDouble());

  ///设置文字大小
  num get sp =>
      ScreenSizeFit.setPx(this.toDouble()) * ScreenSizeFit.textScaleFactor;

  ///设置实际像素大小
  ///例如 1像素 SizeConstant.size_pix_1
  num get pix => this.toDouble() / window.devicePixelRatio;
}
""";
