String clazzTplGuardWidget({package}) => """
import 'package:flutter/material.dart';
import 'package:$package/widget/base_store_container.dart';

/// 请叫我code哥
/// Generates Dart code
class GuardWidget extends StatelessWidget {
  ///路由守卫
  final Widget child;

  GuardWidget({Key key, this.child}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return BaseStoreContainer(
      onInitialBuild: (store) {
        //自己可以根据需要修改，或请求登入或读取本地token
        if ((store.state?.userInfoState?.token?.length ?? 0) <= 0) {
          //不存在登录态,跳转login页面
          Navigator.push(
              context,
              PageRouteBuilder(
                pageBuilder: (
                  BuildContext context,
                  Animation<double> animation,
                  Animation<double> secondaryAnimation,
                ) {
                  return Scaffold(
                    appBar: AppBar(
                      title: Text('Login'),
                    ),
                    body: Center(
                      child: Text('this is Login Page'),
                    ),
                  );
                },
                transitionsBuilder: (
                  BuildContext context,
                  Animation<double> animation,
                  Animation<double> secondaryAnimation,
                  Widget child,
                ) {
                  return SlideTransition(
                    position: Tween<Offset>(
                      begin: Offset(0.0, 1.0),
                      end: Offset(0.0, 0.0),
                    ).animate(
                      CurvedAnimation(parent: animation, curve: Curves.ease),
                    ),
                    child: child,
                  );
                },
                transitionDuration: Duration(milliseconds: 500),
              ));
        }
      },
      builder: (context, store) => child,
    );
  }
}
""";
